# Generated by Django 3.2.8 on 2022-11-28 06:44

from django.db import migrations, models
import django.db.models.deletion
import lib.utils


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('host', '__first__'),
        ('accounts', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='SubscribeModel',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.CharField(default=lib.utils.human_datetime, max_length=20, verbose_name='创建时间')),
                ('deleted_at', models.CharField(max_length=20, null=True)),
                ('title', models.CharField(max_length=128, unique=True, verbose_name='订阅名称')),
                ('users', models.ManyToManyField(related_name='subs', to='accounts.User')),
            ],
            options={
                'db_table': 'sys_subscribe',
            },
        ),
        migrations.CreateModel(
            name='AlarmModel',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.CharField(default=lib.utils.human_datetime, max_length=20, verbose_name='创建时间')),
                ('deleted_at', models.CharField(max_length=20, null=True)),
                ('noticelcon_type', models.SmallIntegerField(choices=[(0, 'notification'), (1, 'warning')], default=0, verbose_name='通知类型')),
                ('level', models.IntegerField(choices=[(0, 'info'), (1, 'warning'), (2, 'error'), (3, 'success')], default=0, verbose_name='告警级别')),
                ('message', models.TextField(verbose_name='告警内容')),
                ('collected_time', models.DateTimeField(verbose_name='告警采集时间')),
                ('duration_time', models.TimeField(blank=True, null=True, verbose_name='告警持续时间')),
                ('item', models.CharField(max_length=100, verbose_name='告警项')),
                ('is_read', models.BooleanField(default=False, verbose_name='是否已读')),
                ('host', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='alarm_hosts', to='host.hostmodel', verbose_name='告警主机')),
                ('receiver', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='alarm_user', to='accounts.user', verbose_name='告警接受者')),
                ('sub', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='alarms', to='alarm.subscribemodel')),
            ],
            options={
                'db_table': 'sys_alarm',
            },
        ),
    ]
